library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Bcd27segm_ver2_VHDL is
    Port ( Bcd :           in std_logic_vector(3 downto 0);
           a,b,c,d,e,f,g : out std_logic);
end Bcd27segm_ver2_VHDL;

architecture Behavioral of Bcd27segm_ver2_VHDL is
	Signal n: integer range 0 to 15;
begin
	n <= Conv_Integer( Bcd);

  ------------------------------------------------------------------
  --Bcd to 7 segment decoder / based on a truthtable from .. .. 
  ------------------------------------------------------------------
	a <= '1' when (n=1)or(n=4)or(n=11)or(n=13) else
	     '0';
	b <= '1' when (n=5)or(n=6)or(n=11)or(n=12)or(n=14)or(n=15) else
	     '0';
	c <= '1' when (n=2)or(n=12)or(n=14)or(n=15) else
	     '0';
	d <= '1' when (n=1)or(n=4)or(n=7)or(n=10)or(n=15) else
	     '0';
	e <= '1' when (n=1)or(n=3)or(n=4)or(n=5)or(n=7)or(n=9) else
	     '0';
	f <= '1' when (n=1)or(n=2)or(n=3)or(n=7)or(n=13) else
	     '0';
	g <= '1' when (n=0)or(n=1)or(n=7)or(n=12) else
	     '0';

end Behavioral;
