--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY TB_Clock_scale IS
END TB_Clock_scale;
 
ARCHITECTURE behavior OF TB_Clock_scale IS 
    -- Component Declaration for the Unit Under Test (UUT)
    COMPONENT Clock_scale
    PORT(
         Clk_50MHz : IN  std_logic;
         Test : IN  std_logic_vector(1 downto 0);
         Clk_xxxHZ : OUT  std_logic );
    END COMPONENT;  
   --------------------------------------------------------------- Inputs
   signal Clk_50MHz : std_logic := '0';
   signal Test : std_logic_vector(1 downto 0) := (others => '0');
 	--------------------------------------------------------------- Outputs
   signal Clk_xxxHZ : std_logic;
   ----------------------------------------------- Clock period definitions
   constant Clk_50MHz_period : time := 20 ns;
BEGIN
	----------------------------------- Instantiate the Unit Under Test (UUT)
   uut: Clock_scale PORT MAP (
          Clk_50MHz => Clk_50MHz,
          Test => Test,
          Clk_xxxHZ => Clk_xxxHZ);
   ------------------------------------------------ Clock process definitions
   Clk_50MHz_process :process
   begin
		Clk_50MHz <= '0';
		wait for Clk_50MHz_period/2;
		Clk_50MHz <= '1';
		wait for Clk_50MHz_period/2;
   end process;
   ----------------------------------------------------------- Stimulus process
   stim_proc: process
   begin		
	   Test <= "10";
      wait for 100 ns;
      Test <= "11";		
      wait;
   end process;
END;
