--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY TB_Mux4x4_1x4_VHDL IS
END TB_Mux4x4_1x4_VHDL;
 
ARCHITECTURE behavior OF TB_Mux4x4_1x4_VHDL IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
    COMPONENT Mux4x4_1x4_VHDL
    PORT(
         A : IN  std_logic_vector(3 downto 0);
         B : IN  std_logic_vector(3 downto 0);
         C : IN  std_logic_vector(3 downto 0);
         D : IN  std_logic_vector(3 downto 0);
         Dp3 : IN  std_logic;
         Dp2 : IN  std_logic;
         Dp1 : IN  std_logic;
         Dp0 : IN  std_logic;
         S1 : IN  std_logic;
         S0 : IN  std_logic;
         Y : OUT  std_logic_vector(3 downto 0);
         Dp : OUT  std_logic);
    END COMPONENT;
    
   --Inputs
   signal A : std_logic_vector(3 downto 0) := (others => '0');
   signal B : std_logic_vector(3 downto 0) := (others => '0');
   signal C : std_logic_vector(3 downto 0) := (others => '0');
   signal D : std_logic_vector(3 downto 0) := (others => '0');
   signal Dp3 : std_logic := '0';
   signal Dp2 : std_logic := '0';
   signal Dp1 : std_logic := '0';
   signal Dp0 : std_logic := '0';
   signal S1 : std_logic := '0';
   signal S0 : std_logic := '0';

 	--Outputs
   signal Y : std_logic_vector(3 downto 0);
   signal Dp : std_logic;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: Mux4x4_1x4_VHDL PORT MAP (
          A => A,
          B => B,
          C => C,
          D => D,
          Dp3 => Dp3,
          Dp2 => Dp2,
          Dp1 => Dp1,
          Dp0 => Dp0,
          S1 => S1,
          S0 => S0,
          Y => Y,
          Dp => Dp);
 
   -- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN
	   A<= "1010"; B<="1011"; C<="1100"; D<="1101";
		Dp3 <= '1'; Dp2<='0';  Dp1 <= '1'; Dp0<='0';
		S1 <= '0'; S0 <= '0';
		WAIT for 20 ns;
		S1 <= '0'; S0 <= '1';
		WAIT for 20 ns;	
		S1 <= '1'; S0 <= '0';
		WAIT for 20 ns;
		S1 <= '1'; S0 <= '1';
		WAIT for 20 ns;		
      WAIT; -- will wait forever
   END PROCESS;
END;
