library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Test_Counter_VHDL is
    Port ( Clk_xxxHz : 				in  std_logic;
           Step_Clk : 				in  std_logic;
           Select_Clk : 			in  std_logic;
           Clr, Count_Enable : 	in  std_logic;
           Bcd0,Bcd1,Bcd2,Bcd3 : out std_logic_vector(3 downto 0));
end Test_Counter_VHDL;

architecture Behavioral of Test_Counter_VHDL is
	Signal Q:   std_logic_vector( 15 downto 0);
   Signal Clk: std_logic;
begin
	-- 2x1bit multiplexer: Clk_xxx or Step_Clk = [Btn0]
   Clk <= Clk_xxxHz when Select_Clk='1' else
	       Step_Clk;
			 			 
	process( Clk, Clr)	
	begin		  
		if Clr='1' then
		   Q <= (others => '0');    -- "0000000000000000"
		elsif rising_edge( Clk) then
		   if Count_Enable='1' then
		      Q <= Q+1;
			end if;
		end if;
	end process;

   Bcd3 <= Q(15 downto 12);
   Bcd2 <= Q(11 downto  8);
   Bcd1 <= Q( 7 downto  4);
   Bcd0 <= Q( 3 downto  0);

end Behavioral;
