library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Clock_scale is
    Port ( Clk_50MHz : in  std_logic;
	        Test:       in  std_logic_vector(1 downto 0);
           Clk_xxxHZ : out std_logic);
end Clock_scale;

architecture Behavioral of Clock_scale is
   signal Q: std_logic_vector(23 downto 0) 
	          := (1=>'0',others=>'1'); --24bit counter
begin
 
 -- 50 MHz Scaled downto xxx Hz
	process( Clk_50MHz)
	begin
	   if rising_edge( Clk_50MHz) then
		   Q <= Q+1;
      end if;
	end process;

 -- Choose among 4 clockfrequenies vlg
	with Test select
		Clk_xxxHz <= Q(17) when "00",
						 Q(18) when "01",
						 Q(23) when "10",
						 Q( 4) when "11",
						 '0'   when others; 
end Behavioral;
